// NOPPP.H (Revised); by Phil Rice 2000

char*	cleanctrl(char *s);
char*	getstring( void );
int	getint( void );
char	getchoice(char *s);
void	clearscreen( void );
int	waitkey( void );
void	errmsg(char *s);
void MyDelay(int k);
word portaddr(int n); 
void datawritable( void );
void datareadable( void );
void vppon( void );
bit datain( void );
void allpinslow( void );
bit  detecthardware( void );
void sendbit(bit b);
bit recvbit( void );
void sendcmd(byte b);
void senddata(word w);
word recvdata( void );
void cleararrays ( void ); 

bit  stuffarray (word address,
                 word array[],
                 word base,
                 word size,
                 word *used,
                 word data[],
                 int  count); 

void vppreset( void ); 


void progcycle(byte cmd, word arg); 

int  progcycle_12c5( word arg, word mask, word base );

void	tiny_p_cycle( word arg);

bit programall_12c5(
             int  mode,
             word mask,
             byte writecommand,
             byte readcommand,
             word array[],
             word base,
             word used);
	     
bit programall(
             int  mode,
             word mask,
             byte writecommand,
             byte readcommand,
             word array[],
             word base,
             word used);

bit readall( word mask,
             byte readcommand,
             word array[],
             word base,
             word used);

void inspect( void);

bit validhexline(char *s);

void loadhexfile(FILE *f);
void banner( void );
void selectport( void );
int  troubleshoot( void );
void load( void );
void selectdevice( void );

void read675cal(  void );
void write675cal( void );
void repair675(   void );

void erase(    void );
void erase675( void );
void erase628( void );

void program(      int mode );
void program675(   int mode );
void program_12c5( int mode );

void queryexit( void );
void menu( void );
int  main( void );
